<?php

//*******************************************************************************
// Sphinx Search v1.0
// Author: Iverest EOOD
// E-mail: sales@iverest.com
// Website: http://www.iverest.com
//*******************************************************************************

require_once DIR_APPLICATION .'../catalog/controller/module/sphinxhelper.php';

class ControllerModuleSphinxsearch extends ControllerModuleSphinxhelper {

	private $LIMIT = 500;

	public function install() {

		$this->db->query("
        CREATE TABLE IF NOT EXISTS `" . DB_PREFIX . "sphinx_suggestions` (
          `id` int(11) NOT NULL AUTO_INCREMENT,
          `keyword` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
          `trigrams` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
          `freq` int(11) NOT NULL ,
          PRIMARY KEY (`id`),
		  UNIQUE KEY `keyword` (`keyword`)
        ) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;");

	}

	public function index() {
		$this->language->load('module/sphinxsearch');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {

			$this->model_setting_setting->editSetting('sphinxsearch', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->redirect($this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL'));
		}

		//Common text
		$this->data['text_enabled'] = $this->language->get('text_enabled');
		$this->data['text_disabled'] = $this->language->get('text_disabled');
		$this->data['text_yes'] = $this->language->get('text_yes');
		$this->data['text_no'] = $this->language->get('text_no');
		$this->data['text_rt_yes'] = $this->language->get('text_rt_yes');
		$this->data['text_rt_no'] = $this->language->get('text_rt_no');
		$this->data['text_calculating'] = $this->language->get('text_calculating');

		//Tabs
		$this->data['heading_title'] = $this->language->get('heading_title');
		$this->data['tab_general'] = $this->language->get('tab_general');
		$this->data['tab_autocomplete'] = $this->language->get('tab_autocomplete');
		$this->data['tab_productOptions'] = $this->language->get('tab_productOptions');
		$this->data['tab_categoriesOptions'] = $this->language->get('tab_categoriesOptions');
		$this->data['tab_suggestions'] = $this->language->get('tab_suggestions');
		$this->data['tab_config'] = $this->language->get('tab_config');

		//General tab
		$this->data['entry_sphinx_status'] = $this->language->get('entry_sphinx_status');
		$this->data['entry_sort_status'] = $this->language->get('entry_sort_status');
		$this->data['entry_autocomplete_status'] = $this->language->get('entry_autocomplete_status');
		$this->data['entry_sphinx_server'] = $this->language->get('entry_sphinx_server');
		$this->data['entry_sphinx_port'] = $this->language->get('entry_sphinx_port');

		$this->data['entry_sphinx_match_mode_title'] = $this->language->get('entry_sphinx_match_mode_title');
		$this->data['entry_sphinx_sort_mode_title'] = $this->language->get('entry_sphinx_sort_mode_title');
		$this->data['entry_sphinx_ranking_mode_title'] = $this->language->get('entry_sphinx_ranking_mode_title');
		$this->data['entry_sphinx_weight_title'] = $this->language->get('entry_sphinx_weight_title');

		$this->data['entry_sphinx_match_mode'] = $this->language->get('entry_sphinx_match_mode');
		$this->data['entry_sphinx_sort_info'] = $this->language->get('entry_sphinx_sort_info');
		$this->data['entry_sphinx_attr_expr_info'] = $this->language->get('entry_sphinx_attr_expr_info');
		$this->data['entry_sphinx_ranking_mode'] = $this->language->get('entry_sphinx_ranking_mode');

		$this->data['entry_sphinx_match_modes_explanation'] = $this->language->get('entry_sphinx_match_modes_explanation');
		$this->data['entry_sphinx_sort_modes_explanation'] = $this->language->get('entry_sphinx_sort_modes_explanation');
		$this->data['entry_sphinx_ranking_modes_explanation'] = $this->language->get('entry_sphinx_ranking_modes_explanation');
		$this->data['entry_sphinx_suggestion_explanation'] = $this->language->get('entry_sphinx_suggestion_explanation');

		$this->data['sphinx_match_modes'] = $this->sphinxMatchModes();
		$this->data['sphinx_sort_modes'] = $this->sphinxSortModes();
		$this->data['sphinx_ranking_modes'] = $this->sphinxRankingModes();
		$this->data['sphinx_sort_attrs'] = $this->sphinxSortAttrs();

		//Autocomplete tabs
		$this->data['entry_sphinx_autocomplete'] = $this->language->get('entry_sphinx_autocomplete');
		$this->data['entry_autocomplete_selector'] = $this->language->get('entry_autocomplete_selector');
		$this->data['entry_autocomplete_limit'] = $this->language->get('entry_autocomplete_limit');
		$this->data['entry_autocomplete_categories'] = $this->language->get('entry_autocomplete_categories');
		$this->data['entry_sphinx_autocomplete_cat_limit'] = $this->language->get('entry_sphinx_autocomplete_cat_limit');

		//Products tab
		$this->data['entry_sphinx_product_status'] = $this->language->get('entry_sphinx_product_status');
		$this->data['entry_sphinx_products_quantity'] = $this->language->get('entry_sphinx_products_quantity');

		//Categories tab
		$this->data['entry_sphinx_category_status'] = $this->language->get('entry_sphinx_category_status');
		$this->data['entry_sphinx_category_product_status'] = $this->language->get('entry_sphinx_category_product_status');
		$this->data['entry_sphinx_categories_product_quantity'] = $this->language->get('entry_sphinx_categories_product_quantity');

		//Suggestions tab
		$this->data['entry_sphinx_gen_btn'] = $this->language->get('entry_sphinx_gen_btn');
		$this->data['entry_sphinx_gen_suggestions'] = $this->language->get('entry_sphinx_gen_suggestions');

		//Config tab
		$this->data['entry_sphinx_config_path_to_indexes'] = $this->language->get('entry_sphinx_config_path_to_indexes');
		$this->data['entry_sphinx_config_path_to_log'] = $this->language->get('entry_sphinx_config_path_to_log');
		$this->data['entry_sphinx_config_index_type'] = $this->language->get('entry_sphinx_config_index_type');
		$this->data['entry_sphinx_config_generate_file'] = $this->language->get('entry_sphinx_config_generate_file');
		$this->data['entry_sphinx_gen_config_btn'] = $this->language->get('entry_sphinx_gen_config_btn');

		//Buttons
		$this->data['button_save'] = $this->language->get('button_save');
		$this->data['button_cancel'] = $this->language->get('button_cancel');
		$this->data['button_add_module'] = $this->language->get('button_add_module');
		$this->data['button_remove'] = $this->language->get('button_remove');

 		if (isset($this->error['warning'])) {
			$this->data['error_warning'] = $this->error['warning'];
		} else {
			$this->data['error_warning'] = '';
		}

  		$this->data['breadcrumbs'] = array();

   		$this->data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_home'),
			'href'      => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),
      		'separator' => false
   		);

   		$this->data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_module'),
			'href'      => $this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL'),
      		'separator' => ' :: '
   		);

   		$this->data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('heading_title'),
			'href'      => $this->url->link('module/sphinxsearch', 'token=' . $this->session->data['token'], 'SSL'),
      		'separator' => ' :: '
   		);

		$this->data['action'] = $this->url->link('module/sphinxsearch', 'token=' . $this->session->data['token'], 'SSL');
		$this->data['cancel'] = $this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL');
		$this->data['token'] = $this->session->data['token'];

		//General tab
		if (isset($this->request->post['sphinx_search_module'])) {
			$this->data['sphinx_search_module'] = $this->request->post['sphinx_search_module'];
		} else {
			$this->data['sphinx_search_module'] = $this->config->get('sphinx_search_module');
		}

		if (isset($this->request->post['sphinx_search_server'])) {
			$this->data['sphinx_search_server'] = $this->request->post['sphinx_search_server'];
		} else {
			$this->data['sphinx_search_server'] = $this->config->get('sphinx_search_server');
		}

		if (isset($this->request->post['sphinx_search_port'])) {
			$this->data['sphinx_search_port'] = $this->request->post['sphinx_search_port'];
		} else {
			$this->data['sphinx_search_port'] = $this->config->get('sphinx_search_port');
		}

		if (isset($this->request->post['sphinx_match_mode'])) {
			$this->data['sphinx_match_mode'] = $this->request->post['sphinx_match_mode'];
		} else {
			$this->data['sphinx_match_mode'] = $this->config->get('sphinx_match_mode');
		}

		if (isset($this->request->post['sphinx_sort_mode'])) {
			$this->data['sphinx_sort_mode'] = $this->request->post['sphinx_sort_mode'];
		} else {
			$this->data['sphinx_sort_mode'] = $this->config->get('sphinx_sort_mode');
		}

		if (isset($this->request->post['sphinx_ranking_mode'])) {
			$this->data['sphinx_ranking_mode'] = $this->request->post['sphinx_ranking_mode'];
		} else {
			$this->data['sphinx_ranking_mode'] = $this->config->get('sphinx_ranking_mode');
		}

		if (isset($this->request->post['sphinx_search_sort'])) {
			$this->data['sphinx_search_sort'] = $this->request->post['sphinx_search_sort'];
		} else {
			$this->data['sphinx_search_sort'] = $this->config->get('sphinx_search_sort');
		}

		if (isset($this->request->post['sphinx_sort_attr_val'])) {
			$this->data['sphinx_sort_attr_val'] = $this->request->post['sphinx_sort_attr_val'];
		} else {
			$this->data['sphinx_sort_attr_val'] = $this->config->get('sphinx_sort_attr_val');
		}

		if (isset($this->request->post['sphinx_weights'])) {
			$this->data['sphinx_weights'] = $this->request->post['sphinx_weights'];
		} else {
			$this->data['sphinx_weights'] = $this->config->get('sphinx_weights');
		}

		//Autocomplete tab
		if (isset($this->request->post['sphinx_search_autocomple'])) {
			$this->data['sphinx_search_autocomple'] = $this->request->post['sphinx_search_autocomple'];
		} else {
			$this->data['sphinx_search_autocomple'] = $this->config->get('sphinx_search_autocomple');
		}

		if (isset($this->request->post['sphinx_autocomple_selector'])) {
			$this->data['sphinx_autocomple_selector'] = $this->request->post['sphinx_autocomple_selector'];
		} else {
			$this->data['sphinx_autocomple_selector'] = $this->config->get('sphinx_autocomple_selector');
		}

		if (isset($this->request->post['sphinx_autocomple_limit'])) {
			$this->data['sphinx_autocomple_limit'] = $this->request->post['sphinx_autocomple_limit'];
		} else {
			$this->data['sphinx_autocomple_limit'] = $this->config->get('sphinx_autocomple_limit');
		}

		if (isset($this->request->post['sphinx_search_autocomplete_categories'])) {
			$this->data['sphinx_search_autocomplete_categories'] = $this->request->post['sphinx_search_autocomplete_categories'];
		} else {
			$this->data['sphinx_search_autocomplete_categories'] = $this->config->get('sphinx_search_autocomplete_categories');
		}

		if (isset($this->request->post['sphinx_autocomplete_cat_limit'])) {
			$this->data['sphinx_autocomplete_cat_limit'] = $this->request->post['sphinx_autocomplete_cat_limit'];
		} else {
			$this->data['sphinx_autocomplete_cat_limit'] = $this->config->get('sphinx_autocomplete_cat_limit');
		}

		//Products tab
		if (isset($this->request->post['sphinx_search_product_status'])) {
			$this->data['sphinx_search_product_status'] = $this->request->post['sphinx_search_product_status'];
		} else {
			$this->data['sphinx_search_product_status'] = $this->config->get('sphinx_search_product_status');
		}

		if (isset($this->request->post['sphinx_search_products_quantity'])) {
			$this->data['sphinx_search_products_quantity'] = $this->request->post['sphinx_search_products_quantity'];
		} else {
			$this->data['sphinx_search_products_quantity'] = $this->config->get('sphinx_search_products_quantity');
		}

		//Categories tab
		if (isset($this->request->post['sphinx_category_status'])) {
			$this->data['sphinx_category_status'] = $this->request->post['sphinx_category_status'];
		} else {
			$this->data['sphinx_category_status'] = $this->config->get('sphinx_category_status');
		}

		if (isset($this->request->post['sphinx_category_product_status'])) {
			$this->data['sphinx_category_product_status'] = $this->request->post['sphinx_category_product_status'];
		} else {
			$this->data['sphinx_category_product_status'] = $this->config->get('sphinx_category_product_status');
		}

		if (isset($this->request->post['sphinx_category_product_quantity'])) {
			$this->data['sphinx_category_product_quantity'] = $this->request->post['sphinx_category_product_quantity'];
		} else {
			$this->data['sphinx_category_product_quantity'] = $this->config->get('sphinx_category_product_quantity');
		}

		//Config tab
		if (isset($this->request->post['sphinx_config_path_to_indexes'])) {
			$this->data['sphinx_config_path_to_indexes'] = $this->request->post['sphinx_config_path_to_indexes'];
		} else {
			$this->data['sphinx_config_path_to_indexes'] = $this->config->get('sphinx_config_path_to_indexes');
		}

		if (isset($this->request->post['sphinx_config_path_to_log'])) {
			$this->data['sphinx_config_path_to_log'] = $this->request->post['sphinx_config_path_to_log'];
		} else {
			$this->data['sphinx_config_path_to_log'] = $this->config->get('sphinx_config_path_to_log');
		}

		if (isset($this->request->post['sphinx_config_index_type'])) {
			$this->data['sphinx_config_index_type'] = $this->request->post['sphinx_config_index_type'];
		} else {
			$this->data['sphinx_config_index_type'] = $this->config->get('sphinx_config_index_type');
		}

		$this->template = 'module/sphinxsearch.tpl';
		$this->children = array(
			'common/header',
			'common/footer'
		);

		$this->document->addStyle('view/stylesheet/sphinx.css');

		$this->response->setOutput($this->render());
	}

	/**
	 * Generate suggestions - gets all products from 'product_description' table, extract the keywords, builds trigrams and freqs
	 */
	public function generateSuggestions() {

		if (!$this->validate()) {
			echo 'You have no permissons to do that!';
			return;
		}

		$timeLimit = (int)ini_get('max_execution_time')-10;
		$timeStart = microtime(true);

		$sphinxClient = $this->initSphinx();

		if(!$sphinxClient) {
			$json = array(
					'error' => 'Sphinx connection error!',
					'offset' => '',
					'limit' => $this->LIMIT,
					'total' => ''
			);
			$this->response->setOutput(json_encode($json));
			return;
		}

		$offset = 0;
		if(isset($this->request->get['offset'])) {
			$offset = (int)$this->request->get['offset'];
		}

		if(!isset($this->session->data['total'])) {
			$query = $this->db->query("SELECT COUNT(*) AS count FROM " . DB_PREFIX . "product_description");
			$count = $query->rows;
			$this->session->data['total'] = (int)$count[0]['count'];
		}

		if($offset == 0) {
			$this->db->query("DELETE FROM `" . DB_PREFIX . "sphinx_suggestions`;");
			$this->db->query("ALTER TABLE `" . DB_PREFIX . "sphinx_suggestions` AUTO_INCREMENT =1;");
		}

		$query = $this->db->query("SELECT name FROM " . DB_PREFIX . "product_description LIMIT ".$offset.','.$this->LIMIT);
		$results = $query->rows;

		$this->db->query("START TRANSACTION;");
		foreach($results as $idx => &$res) {

			if (microtime(true) - $timeStart >= $timeLimit) {
				break;
			}

			$keywords = $sphinxClient->BuildKeywords($res['name'], 'main', true);

			foreach ($keywords as $key => &$arr) {
				$trigrams = $this->buildTrigrams($arr['tokenized']);
				$this->db->query("INSERT IGNORE INTO `" . DB_PREFIX . "sphinx_suggestions` (`keyword`, `trigrams`, `freq`) VALUES ('".$arr['tokenized']."', '".$trigrams."', ".$arr['hits'].");");
			}

		}

		$this->db->query("COMMIT;");
		$json = array(
			'error' => '',
			'offset' => $offset+$idx+1,
			'limit' => $this->LIMIT,
			'total' => $this->session->data['total']
		);

		$this->response->setOutput(json_encode($json));

	}

	public function generateSphinxConfig() {

		$baseFile = DIR_SYSTEM .'library/sphinx/sphinx.conf.in';
		$newConfigFile = DIR_DOWNLOAD .'sphinx.conf';
		$baseFileContent = file_get_contents($baseFile);

		$find = array(
			'{{ sphinx_config_db_host }}',
			'{{ sphinx_config_db_user }}',
			'{{ sphinx_config_db_pass }}',
			'{{ sphinx_config_db_name }}',
			'{{ sphinx_config_db_table_prefix }}',
			'{{ sphinx_config_path_to_indexes }}',
			'{{ sphinx_config_path_to_log }}'
		);

		$replace = array(
			DB_HOSTNAME,
			DB_USERNAME,
			DB_PASSWORD,
			DB_DATABASE,
			DB_PREFIX,
			$this->config->get('sphinx_config_path_to_indexes'),
			$this->config->get('sphinx_config_path_to_log')
		);

		$newContent = str_replace($find, $replace, $baseFileContent);

		file_put_contents($newConfigFile, $newContent);

		if (file_exists($newConfigFile)) {
			header('Content-Description: File Transfer');
			header('Content-Type: application/octet-stream');
			header('Content-Disposition: attachment; filename='.basename($newConfigFile));
			readfile($newConfigFile);
		}

		unlink($newConfigFile);

	}

	public function buildRtIndexes() {

		$this->load->model('catalog/sphinx');

		$offset = 0;
		if(isset($this->request->get['offset'])) {
			$offset = (int)$this->request->get['offset'];
		}

		$currentTable = 1;
		if(isset($this->request->get['currentTable'])) {
			$currentTable = (int)$this->request->get['currentTable'];
		}

		$data = array(
			'tableNames' => array(1 => 'product', 2 => 'sphinx_suggestions', 3 => 'category_description'),
			'currentTable' => $currentTable,
			'offset' => $offset,
			'limit' => $this->LIMIT
		);

		$json = $this->model_catalog_sphinx->insertDataToRtIndex($data);

		$this->response->setOutput(json_encode($json));

	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'module/sphinxsearch')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if (!$this->error) {
			return true;
		} else {
			return false;
		}
	}

}

?>